Index: abi/include/mm/as.h
===================================================================
--- abi/include/mm/as.h	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ abi/include/mm/as.h	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -37,8 +37,10 @@
 
 /** Address space area flags. */
-#define AS_AREA_READ       1
-#define AS_AREA_WRITE      2
-#define AS_AREA_EXEC       4
-#define AS_AREA_CACHEABLE  8
+#define AS_AREA_READ         0x01
+#define AS_AREA_WRITE        0x02
+#define AS_AREA_EXEC         0x04
+#define AS_AREA_CACHEABLE    0x08
+#define AS_AREA_GUARD        0x10
+#define AS_AREA_LATE_RESERVE 0x20
 
 /** Address space area info exported to uspace. */
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ boot/Makefile.common	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -109,5 +109,4 @@
 	$(USPACE_PATH)/srv/fs/exfat/exfat \
 	$(USPACE_PATH)/srv/fs/udf/udf \
-	$(USPACE_PATH)/srv/fs/ext2fs/ext2fs \
 	$(USPACE_PATH)/srv/fs/ext4fs/ext4fs \
 	$(USPACE_PATH)/srv/hid/remcons/remcons \
@@ -167,5 +166,4 @@
 	$(USPACE_PATH)/app/dload/dload \
 	$(USPACE_PATH)/app/edit/edit \
-	$(USPACE_PATH)/app/ext2info/ext2info \
 	$(USPACE_PATH)/app/inet/inet \
 	$(USPACE_PATH)/app/kill/kill \
Index: boot/arch/ia64/src/main.c
===================================================================
--- boot/arch/ia64/src/main.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ boot/arch/ia64/src/main.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -48,5 +48,5 @@
 
 #define DEFAULT_MEMORY_BASE		0x4000000ULL
-#define DEFAULT_MEMORY_SIZE		0x4000000ULL
+#define DEFAULT_MEMORY_SIZE		(256 * 1024 * 1024)
 #define DEFAULT_LEGACY_IO_BASE		0x00000FFFFC000000ULL
 #define DEFAULT_LEGACY_IO_SIZE		0x4000000ULL
Index: contrib/conf/ski.conf
===================================================================
--- contrib/conf/ski.conf	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ contrib/conf/ski.conf	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -1,1 +1,1 @@
-load HelenOS/image.boot
+load image.boot
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/arch/amd64/Makefile.inc	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -33,24 +33,5 @@
 
 FPU_NO_CFLAGS = -mno-sse -mno-sse2
-
-#
-# FIXME:
-#
-# The -fno-optimize-sibling-calls should be removed as soon as a bug
-# in GCC concerning the "large" memory model and tail call optimization
-# is fixed.
-#
-# When GCC generates a code for tail call, instead of generating ..
-#
-#   jmp *fnc
-#
-# it generates an assembly code with an illegal immediate prefix:
-#
-#   jmp *$fnc
-#
-# See http://gcc.gnu.org/bugzilla/show_bug.cgi?id=48385 for reference.
-#
-
-CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer -fno-optimize-sibling-calls
+CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
Index: kernel/arch/ia64/include/mm/as.h
===================================================================
--- kernel/arch/ia64/include/mm/as.h	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/arch/ia64/include/mm/as.h	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -43,6 +43,4 @@
 #define USER_ADDRESS_SPACE_END_ARCH      UINT64_C(0xdfffffffffffffff)
 
-#define USTACK_ADDRESS_ARCH  UINT64_C(0x0000000ff0000000)
-
 typedef struct {
 } as_arch_t;
Index: kernel/arch/ia64/src/mm/tlb.c
===================================================================
--- kernel/arch/ia64/src/mm/tlb.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/arch/ia64/src/mm/tlb.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -113,6 +113,6 @@
 	va = page;
 	
-	rr.word = rr_read(VA2VRN(va));
-	if ((restore_rr = (rr.map.rid != ASID2RID(asid, VA2VRN(va))))) {
+	rr.word = rr_read(VA2VRN(page));
+	if ((restore_rr = (rr.map.rid != ASID2RID(asid, VA2VRN(page))))) {
 		/*
 		 * The selected region register does not contain required RID.
@@ -122,6 +122,6 @@
 		
 		rr0 = rr;
-		rr0.map.rid = ASID2RID(asid, VA2VRN(va));
-		rr_write(VA2VRN(va), rr0.word);
+		rr0.map.rid = ASID2RID(asid, VA2VRN(page));
+		rr_write(VA2VRN(page), rr0.word);
 		srlz_d();
 		srlz_i();
@@ -139,38 +139,38 @@
 	case 1: /* cnt 4 - 15 */
 		ps = PAGE_WIDTH + 2;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	case 2: /* cnt 16 - 63 */
 		ps = PAGE_WIDTH + 4;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	case 3: /* cnt 64 - 255 */
 		ps = PAGE_WIDTH + 6;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	case 4: /* cnt 256 - 1023 */
 		ps = PAGE_WIDTH + 8;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	case 5: /* cnt 1024 - 4095 */
 		ps = PAGE_WIDTH + 10;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	case 6: /* cnt 4096 - 16383 */
 		ps = PAGE_WIDTH + 12;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	case 7: /* cnt 16384 - 65535 */
 	case 8: /* cnt 65536 - (256K - 1) */
 		ps = PAGE_WIDTH + 14;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	default:
 		ps = PAGE_WIDTH + 18;
-		va &= ~((1 << ps) - 1);
+		va &= ~((1UL << ps) - 1);
 		break;
 	}
 	
-	for (; va < (page + cnt * PAGE_SIZE); va += (1 << ps))
+	for (; va < (page + cnt * PAGE_SIZE); va += (1UL << ps))
 		asm volatile (
 			"ptc.l %[va], %[ps] ;;"
@@ -183,5 +183,5 @@
 	
 	if (restore_rr) {
-		rr_write(VA2VRN(va), rr.word);
+		rr_write(VA2VRN(page), rr.word);
 		srlz_d();
 		srlz_i();
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/arch/ppc32/src/ppc32.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -103,4 +103,5 @@
 }
 
+#ifdef CONFIG_FB
 static bool display_register(ofw_tree_node_t *node, void *arg)
 {
@@ -169,4 +170,5 @@
 	return true;
 }
+#endif
 
 void arch_post_mm_init(void)
Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/genarch/src/mm/page_ht.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -209,4 +209,8 @@
 		pte->frame = ALIGN_DOWN(frame, FRAME_SIZE);
 
+		/*
+		 * Make sure that a concurrent ht_mapping_find() will see the
+		 * new entry only after it is fully initialized.
+		 */
 		write_barrier();
 		
Index: kernel/genarch/src/mm/page_pt.c
===================================================================
--- kernel/genarch/src/mm/page_pt.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/genarch/src/mm/page_pt.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -89,4 +89,9 @@
 		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
+		/*
+		 * Make sure that a concurrent hardware page table walk or
+		 * pt_mapping_find() will see the new PTL1 only after it is
+		 * fully initialized.
+		 */
 		write_barrier();
 		SET_PTL1_PRESENT(ptl0, PTL0_INDEX(page));
@@ -103,4 +108,7 @@
 		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
+		/*
+		 * Make the new PTL2 visible only after it is fully initialized.
+		 */
 		write_barrier();
 		SET_PTL2_PRESENT(ptl1, PTL1_INDEX(page));	
@@ -117,4 +125,7 @@
 		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
+		/*
+		 * Make the new PTL3 visible only after it is fully initialized.
+		 */
 		write_barrier();
 		SET_PTL3_PRESENT(ptl2, PTL2_INDEX(page));
@@ -125,4 +136,7 @@
 	SET_FRAME_ADDRESS(ptl3, PTL3_INDEX(page), frame);
 	SET_FRAME_FLAGS(ptl3, PTL3_INDEX(page), flags | PAGE_NOT_PRESENT);
+	/*
+	 * Make the new mapping visible only after it is fully initialized.
+	 */
 	write_barrier();
 	SET_FRAME_PRESENT(ptl3, PTL3_INDEX(page));
@@ -296,4 +310,7 @@
 
 #if (PTL1_ENTRIES != 0)
+	/*
+	 * Always read ptl2 only after we are sure it is present.
+	 */
 	read_barrier();
 #endif
@@ -304,4 +321,7 @@
 
 #if (PTL2_ENTRIES != 0)
+	/*
+	 * Always read ptl3 only after we are sure it is present.
+	 */
 	read_barrier();
 #endif
Index: kernel/generic/include/config.h
===================================================================
--- kernel/generic/include/config.h	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/include/config.h	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -44,4 +44,6 @@
 #define STACK_FRAMES  TWO_FRAMES
 #define STACK_SIZE    ((1 << STACK_FRAMES) << PAGE_WIDTH)
+
+#define STACK_SIZE_USER	(1 * 1024 * 1024)
 
 #define CONFIG_INIT_TASKS        32
Index: kernel/generic/include/macros.h
===================================================================
--- kernel/generic/include/macros.h	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/include/macros.h	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -52,8 +52,19 @@
     uint64_t sz2)
 {
-	uint64_t e1 = s1 + sz1;
-	uint64_t e2 = s2 + sz2;
-	
-	return ((s1 < e2) && (s2 < e1));
+	uint64_t e1 = s1 + sz1 - 1;
+	uint64_t e2 = s2 + sz2 - 1;
+
+	/* both sizes are non-zero */
+	if (sz1 && sz2)
+		return ((s1 <= e2) && (s2 <= e1));
+
+	/* one size is non-zero */
+	if (sz2)
+		return ((s1 >= s2) && (s1 <= e2));
+	if (sz1)
+		return ((s2 >= s1) && (s2 <= e1));
+
+	/* both are zero */
+	return (s1 == s2);
 }
 
@@ -119,4 +130,12 @@
 	    | ((((uint64_t) (up)) & UINT32_C(0xffffffff)) << 32))
 
+/* Test for sum overflow. */
+#define overflows(a, b) \
+	((a) + (b) < (a))
+
+/* Test for sum overflow into positive numbers. */
+#define overflows_into_positive(a, b)	\
+	(overflows((a), (b)) && ((a) + (b) > 0))
+
 /** Pseudorandom generator
  *
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/include/mm/as.h	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -61,10 +61,4 @@
 #define USER_ADDRESS_SPACE_END      USER_ADDRESS_SPACE_END_ARCH
 
-#ifdef USTACK_ADDRESS_ARCH
-	#define USTACK_ADDRESS  USTACK_ADDRESS_ARCH
-#else
-	#define USTACK_ADDRESS  (USER_ADDRESS_SPACE_END - (STACK_SIZE - 1))
-#endif
-
 /** Kernel address space. */
 #define FLAG_AS_KERNEL  (1 << 0)
@@ -224,4 +218,7 @@
 	void (* destroy)(as_area_t *);
 
+	bool (* is_resizable)(as_area_t *);
+	bool (* is_shareable)(as_area_t *);
+
 	int (* page_fault)(as_area_t *, uintptr_t, pf_access_t);
 	void (* frame_free)(as_area_t *, uintptr_t, uintptr_t);
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/include/proc/task.h	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -134,4 +134,7 @@
 	uint64_t ucycles;
 	uint64_t kcycles;
+
+	/** If true, do not attempt to print a verbose kill message. */ 
+	bool silent_kill;
 } task_t;
 
Index: kernel/generic/src/interrupt/interrupt.c
===================================================================
--- kernel/generic/src/interrupt/interrupt.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/interrupt/interrupt.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -168,14 +168,16 @@
 static NO_TRACE void fault_from_uspace_core(istate_t *istate, const char *fmt, va_list args)
 {
-	printf("Task %s (%" PRIu64 ") killed due to an exception at "
-	    "program counter %p.\n", TASK->name, TASK->taskid,
-	    (void *) istate_get_pc(istate));
-	
-	istate_decode(istate);
-	stack_trace_istate(istate);
-	
-	printf("Kill message: ");
-	vprintf(fmt, args);
-	printf("\n");
+	if (!TASK->silent_kill) {
+		printf("Task %s (%" PRIu64 ") killed due to an exception at "
+		    "program counter %p.\n", TASK->name, TASK->taskid,
+		    (void *) istate_get_pc(istate));
+	
+		istate_decode(istate);
+		stack_trace_istate(istate);
+	
+		printf("Kill message: ");
+		vprintf(fmt, args);
+		printf("\n");
+	}
 	
 	task_kill_self(true);
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/main/kinit.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -172,4 +172,10 @@
 #endif /* CONFIG_KCONSOLE */
 	
+	/*
+	 * Store the default stack size in sysinfo so that uspace can create
+	 * stack with this default size.
+	 */
+	sysinfo_set_item_val("default.stack_size", NULL, STACK_SIZE_USER);
+	
 	interrupts_enable();
 	
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/mm/as.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -285,8 +285,9 @@
 /** Check area conflicts with other areas.
  *
- * @param as    Address space.
- * @param addr  Starting virtual address of the area being tested.
- * @param count Number of pages in the area being tested.
- * @param avoid Do not touch this area.
+ * @param as      Address space.
+ * @param addr    Starting virtual address of the area being tested.
+ * @param count   Number of pages in the area being tested.
+ * @param guarded True if the area being tested is protected by guard pages.
+ * @param avoid   Do not touch this area.
  *
  * @return True if there is no conflict, false otherwise.
@@ -294,8 +295,15 @@
  */
 NO_TRACE static bool check_area_conflicts(as_t *as, uintptr_t addr,
-    size_t count, as_area_t *avoid)
+    size_t count, bool guarded, as_area_t *avoid)
 {
 	ASSERT((addr % PAGE_SIZE) == 0);
 	ASSERT(mutex_locked(&as->lock));
+
+	/*
+	 * If the addition of the supposed area address and size overflows,
+	 * report conflict.
+	 */
+	if (overflows_into_positive(addr, P2SZ(count)))
+		return false;
 	
 	/*
@@ -304,5 +312,5 @@
 	if (overlaps(addr, P2SZ(count), (uintptr_t) NULL, PAGE_SIZE))
 		return false;
-	
+
 	/*
 	 * The leaf node is found in O(log n), where n is proportional to
@@ -328,6 +336,51 @@
 		if (area != avoid) {
 			mutex_lock(&area->lock);
-			
+
+			/*
+			 * If at least one of the two areas are protected
+			 * by the AS_AREA_GUARD flag then we must be sure
+			 * that they are separated by at least one unmapped
+			 * page.
+			 */
+			int const gp = (guarded || 
+			    (area->flags & AS_AREA_GUARD)) ? 1 : 0;
+			
+			/*
+			 * The area comes from the left neighbour node, which
+			 * means that there already are some areas in the leaf
+			 * node, which in turn means that adding gp is safe and
+			 * will not cause an integer overflow.
+			 */
 			if (overlaps(addr, P2SZ(count), area->base,
+			    P2SZ(area->pages + gp))) {
+				mutex_unlock(&area->lock);
+				return false;
+			}
+			
+			mutex_unlock(&area->lock);
+		}
+	}
+	
+	node = btree_leaf_node_right_neighbour(&as->as_area_btree, leaf);
+	if (node) {
+		area = (as_area_t *) node->value[0];
+		
+		if (area != avoid) {
+			int gp;
+
+			mutex_lock(&area->lock);
+
+			gp = (guarded || (area->flags & AS_AREA_GUARD)) ? 1 : 0;
+			if (gp && overflows(addr, P2SZ(count))) {
+				/*
+				 * Guard page not needed if the supposed area
+				 * is adjacent to the end of the address space.
+				 * We already know that the following test is
+				 * going to fail...
+				 */
+				gp--;
+			}
+			
+			if (overlaps(addr, P2SZ(count + gp), area->base,
 			    P2SZ(area->pages))) {
 				mutex_unlock(&area->lock);
@@ -339,25 +392,10 @@
 	}
 	
-	node = btree_leaf_node_right_neighbour(&as->as_area_btree, leaf);
-	if (node) {
-		area = (as_area_t *) node->value[0];
-		
-		if (area != avoid) {
-			mutex_lock(&area->lock);
-			
-			if (overlaps(addr, P2SZ(count), area->base,
-			    P2SZ(area->pages))) {
-				mutex_unlock(&area->lock);
-				return false;
-			}
-			
-			mutex_unlock(&area->lock);
-		}
-	}
-	
 	/* Second, check the leaf node. */
 	btree_key_t i;
 	for (i = 0; i < leaf->keys; i++) {
 		area = (as_area_t *) leaf->value[i];
+		int agp;
+		int gp;
 		
 		if (area == avoid)
@@ -365,7 +403,18 @@
 		
 		mutex_lock(&area->lock);
-		
-		if (overlaps(addr, P2SZ(count), area->base,
-		    P2SZ(area->pages))) {
+
+		gp = (guarded || (area->flags & AS_AREA_GUARD)) ? 1 : 0;
+		agp = gp;
+
+		/*
+		 * Sanitize the two possible unsigned integer overflows.
+		 */
+		if (gp && overflows(addr, P2SZ(count)))
+			gp--;
+		if (agp && overflows(area->base, P2SZ(area->pages)))
+			agp--;
+
+		if (overlaps(addr, P2SZ(count + gp), area->base,
+		    P2SZ(area->pages + agp))) {
 			mutex_unlock(&area->lock);
 			return false;
@@ -377,9 +426,10 @@
 	/*
 	 * So far, the area does not conflict with other areas.
-	 * Check if it doesn't conflict with kernel address space.
+	 * Check if it is contained in the user address space.
 	 */
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
-		return !overlaps(addr, P2SZ(count), KERNEL_ADDRESS_SPACE_START,
-		    KERNEL_ADDRESS_SPACE_END - KERNEL_ADDRESS_SPACE_START);
+		return iswithin(USER_ADDRESS_SPACE_START,
+		    (USER_ADDRESS_SPACE_END - USER_ADDRESS_SPACE_START) + 1,
+		    addr, P2SZ(count));
 	}
 	
@@ -392,7 +442,8 @@
  * this function.
  *
- * @param as    Address space.
- * @param bound Lowest address bound.
- * @param size  Requested size of the allocation.
+ * @param as      Address space.
+ * @param bound   Lowest address bound.
+ * @param size    Requested size of the allocation.
+ * @param guarded True if the allocation must be protected by guard pages.
  *
  * @return Address of the beginning of unmapped address space area.
@@ -401,5 +452,5 @@
  */
 NO_TRACE static uintptr_t as_get_unmapped_area(as_t *as, uintptr_t bound,
-    size_t size)
+    size_t size, bool guarded)
 {
 	ASSERT(mutex_locked(&as->lock));
@@ -423,7 +474,15 @@
 	/* First check the bound address itself */
 	uintptr_t addr = ALIGN_UP(bound, PAGE_SIZE);
-	if ((addr >= bound) &&
-	    (check_area_conflicts(as, addr, pages, NULL)))
-		return addr;
+	if (addr >= bound) {
+		if (guarded) {
+			/* Leave an unmapped page between the lower
+			 * bound and the area's start address.
+			 */
+			addr += P2SZ(1);
+		}
+
+		if (check_area_conflicts(as, addr, pages, guarded, NULL))
+			return addr;
+	}
 	
 	/* Eventually check the addresses behind each area */
@@ -439,7 +498,15 @@
 			addr =
 			    ALIGN_UP(area->base + P2SZ(area->pages), PAGE_SIZE);
+
+			if (guarded || area->flags & AS_AREA_GUARD) {
+				/* We must leave an unmapped page
+				 * between the two areas.
+				 */
+				addr += P2SZ(1);
+			}
+
 			bool avail =
 			    ((addr >= bound) && (addr >= area->base) &&
-			    (check_area_conflicts(as, addr, pages, area)));
+			    (check_area_conflicts(as, addr, pages, guarded, area)));
 			
 			mutex_unlock(&area->lock);
@@ -481,5 +548,5 @@
 	if (size == 0)
 		return NULL;
-	
+
 	size_t pages = SIZE2FRAMES(size);
 	
@@ -487,9 +554,11 @@
 	if ((flags & AS_AREA_EXEC) && (flags & AS_AREA_WRITE))
 		return NULL;
+
+	bool const guarded = flags & AS_AREA_GUARD;
 	
 	mutex_lock(&as->lock);
 	
 	if (*base == (uintptr_t) -1) {
-		*base = as_get_unmapped_area(as, bound, size);
+		*base = as_get_unmapped_area(as, bound, size, guarded);
 		if (*base == (uintptr_t) -1) {
 			mutex_unlock(&as->lock);
@@ -497,6 +566,9 @@
 		}
 	}
-	
-	if (!check_area_conflicts(as, *base, pages, NULL)) {
+
+	if (overflows_into_positive(*base, size))
+		return NULL;
+
+	if (!check_area_conflicts(as, *base, pages, guarded, NULL)) {
 		mutex_unlock(&as->lock);
 		return NULL;
@@ -625,9 +697,8 @@
 		return ENOENT;
 	}
-	
-	if (area->backend == &phys_backend) {
-		/*
-		 * Remapping of address space areas associated
-		 * with memory mapped devices is not supported.
+
+	if (!area->backend->is_resizable(area)) {
+		/*
+		 * The backend does not support resizing for this area.
 		 */
 		mutex_unlock(&area->lock);
@@ -776,7 +847,14 @@
 		/*
 		 * Growing the area.
+		 */
+
+		if (overflows_into_positive(address, P2SZ(pages)))
+			return EINVAL;
+
+		/*
 		 * Check for overlaps with other address space areas.
 		 */
-		if (!check_area_conflicts(as, address, pages, area)) {
+		bool const guarded = area->flags & AS_AREA_GUARD;
+		if (!check_area_conflicts(as, address, pages, guarded, area)) {
 			mutex_unlock(&area->lock);
 			mutex_unlock(&as->lock);
@@ -979,8 +1057,7 @@
 	}
 	
-	if ((!src_area->backend) || (!src_area->backend->share)) {
-		/*
-		 * There is no backend or the backend does not
-		 * know how to share the area.
+	if (!src_area->backend->is_shareable(src_area)) {
+		/*
+		 * The backend does not permit sharing of this area.
 		 */
 		mutex_unlock(&src_area->lock);
Index: kernel/generic/src/mm/backend_anon.c
===================================================================
--- kernel/generic/src/mm/backend_anon.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/mm/backend_anon.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -59,4 +59,7 @@
 static void anon_destroy(as_area_t *);
 
+static bool anon_is_resizable(as_area_t *);
+static bool anon_is_shareable(as_area_t *);
+
 static int anon_page_fault(as_area_t *, uintptr_t, pf_access_t);
 static void anon_frame_free(as_area_t *, uintptr_t, uintptr_t);
@@ -68,4 +71,7 @@
 	.destroy = anon_destroy,
 
+	.is_resizable = anon_is_resizable,
+	.is_shareable = anon_is_shareable,
+
 	.page_fault = anon_page_fault,
 	.frame_free = anon_frame_free,
@@ -74,4 +80,7 @@
 bool anon_create(as_area_t *area)
 {
+	if (area->flags & AS_AREA_LATE_RESERVE)
+		return true;
+
 	return reserve_try_alloc(area->pages);
 }
@@ -79,4 +88,7 @@
 bool anon_resize(as_area_t *area, size_t new_pages)
 {
+	if (area->flags & AS_AREA_LATE_RESERVE)
+		return true;
+
 	if (new_pages > area->pages)
 		return reserve_try_alloc(new_pages - area->pages);
@@ -100,4 +112,5 @@
 	ASSERT(mutex_locked(&area->as->lock));
 	ASSERT(mutex_locked(&area->lock));
+	ASSERT(!(area->flags & AS_AREA_LATE_RESERVE));
 
 	/*
@@ -139,7 +152,19 @@
 void anon_destroy(as_area_t *area)
 {
+	if (area->flags & AS_AREA_LATE_RESERVE)
+		return;
+
 	reserve_free(area->pages);
 }
 
+bool anon_is_resizable(as_area_t *area)
+{
+	return true;
+}
+
+bool anon_is_shareable(as_area_t *area)
+{
+	return !(area->flags & AS_AREA_LATE_RESERVE);
+}
 
 /** Service a page fault in the anonymous memory address space area.
@@ -225,4 +250,18 @@
 		 *   the different causes
 		 */
+
+		if (area->flags & AS_AREA_LATE_RESERVE) {
+			/*
+			 * Reserve the memory for this page now.
+			 */
+			if (!reserve_try_alloc(1)) {
+				printf("Killing task %" PRIu64 " due to a "
+				    "failed late reservation request.\n",
+				    TASK->taskid);
+				TASK->silent_kill = true;
+				return AS_PF_FAULT;
+			}
+		}
+
 		kpage = km_temporary_page_get(&frame, FRAME_NO_RESERVE);
 		memsetb((void *) kpage, PAGE_SIZE, 0);
@@ -255,5 +294,19 @@
 	ASSERT(mutex_locked(&area->lock));
 
-	frame_free_noreserve(frame);
+	if (area->flags & AS_AREA_LATE_RESERVE) {
+		/*
+		 * In case of the late reserve areas, physical memory will not
+		 * be unreserved when the area is destroyed so we need to use
+		 * the normal unreserving frame_free().
+		 */
+		frame_free(frame);
+	} else {
+		/*
+		 * The reserve will be given back when the area is destroyed or
+		 * resized, so use the frame_free_noreserve() which does not
+		 * manipulate the reserve or it would be given back twice.
+		 */
+		frame_free_noreserve(frame);
+	}
 }
 
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/mm/backend_elf.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -58,4 +58,7 @@
 static void elf_destroy(as_area_t *);
 
+static bool elf_is_resizable(as_area_t *);
+static bool elf_is_shareable(as_area_t *);
+
 static int elf_page_fault(as_area_t *, uintptr_t, pf_access_t);
 static void elf_frame_free(as_area_t *, uintptr_t, uintptr_t);
@@ -66,4 +69,7 @@
 	.share = elf_share,
 	.destroy = elf_destroy,
+
+	.is_resizable = elf_is_resizable,
+	.is_shareable = elf_is_shareable,
 
 	.page_fault = elf_page_fault,
@@ -213,4 +219,15 @@
 }
 
+bool elf_is_resizable(as_area_t *area)
+{
+	return true;
+}
+
+bool elf_is_shareable(as_area_t *area)
+{
+	return true;
+}
+
+
 /** Service a page fault in the ELF backend address space area.
  *
Index: kernel/generic/src/mm/backend_phys.c
===================================================================
--- kernel/generic/src/mm/backend_phys.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/mm/backend_phys.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -52,4 +52,8 @@
 static void phys_destroy(as_area_t *);
 
+static bool phys_is_resizable(as_area_t *);
+static bool phys_is_shareable(as_area_t *);
+
+
 static int phys_page_fault(as_area_t *, uintptr_t, pf_access_t);
 
@@ -59,4 +63,7 @@
 	.share = phys_share,
 	.destroy = phys_destroy,
+
+	.is_resizable = phys_is_resizable,
+	.is_shareable = phys_is_shareable,
 
 	.page_fault = phys_page_fault,
@@ -87,4 +94,15 @@
 	/* Nothing to do. */
 }
+
+bool phys_is_resizable(as_area_t *area)
+{
+	return false;
+}
+
+bool phys_is_shareable(as_area_t *area)
+{
+	return true;
+}
+
 
 /** Service a page fault in the address space area backed by physical memory.
Index: kernel/generic/src/mm/km.c
===================================================================
--- kernel/generic/src/mm/km.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/mm/km.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -233,5 +233,6 @@
  * @param[inout] framep	Pointer to a variable which will receive the physical
  *			address of the allocated frame.
- * @param[in] flags	Frame allocation flags. FRAME_NONE or FRAME_NO_RESERVE.
+ * @param[in] flags	Frame allocation flags. FRAME_NONE, FRAME_NO_RESERVE
+ *			and FRAME_ATOMIC bits are allowed.
  * @return		Virtual address of the allocated frame.
  */
@@ -243,5 +244,5 @@
 	ASSERT(THREAD);
 	ASSERT(framep);
-	ASSERT(!(flags & ~FRAME_NO_RESERVE));
+	ASSERT(!(flags & ~(FRAME_NO_RESERVE | FRAME_ATOMIC)));
 
 	/*
@@ -255,6 +256,8 @@
 		ASSERT(page);	// FIXME
 	} else {
-		frame = (uintptr_t) frame_alloc_noreserve(ONE_FRAME,
-		    FRAME_LOWMEM);
+		frame = (uintptr_t) frame_alloc(ONE_FRAME,
+		    FRAME_LOWMEM | flags);
+		if (!frame)
+			return (uintptr_t) NULL;
 		page = PA2KA(frame);
 	}
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/proc/program.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -79,8 +79,14 @@
 	 * Create the stack address space area.
 	 */
-	uintptr_t virt = USTACK_ADDRESS;
+	uintptr_t virt = (uintptr_t) -1;
+	uintptr_t bound = USER_ADDRESS_SPACE_END - (STACK_SIZE_USER - 1);
+
+	/* Adjust bound to create space for the desired guard page. */
+	bound -= PAGE_SIZE;
+
 	as_area_t *area = as_area_create(as,
-	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE,
-	    STACK_SIZE, AS_AREA_ATTR_NONE, &anon_backend, NULL, &virt, 0);
+	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE | AS_AREA_GUARD |
+	    AS_AREA_LATE_RESERVE, STACK_SIZE_USER, AS_AREA_ATTR_NONE,
+	    &anon_backend, NULL, &virt, bound);
 	if (!area) {
 		task_destroy(prg->task);
@@ -93,5 +99,5 @@
 	kernel_uarg->uspace_entry = (void *) entry_addr;
 	kernel_uarg->uspace_stack = (void *) virt;
-	kernel_uarg->uspace_stack_size = STACK_SIZE;
+	kernel_uarg->uspace_stack_size = STACK_SIZE_USER;
 	kernel_uarg->uspace_thread_function = NULL;
 	kernel_uarg->uspace_thread_arg = NULL;
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ kernel/generic/src/proc/task.c	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -196,4 +196,6 @@
 	task->ucycles = 0;
 	task->kcycles = 0;
+
+	task->silent_kill = false;
 	
 	task->ipc_info.call_sent = 0;
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ uspace/Makefile	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -40,5 +40,4 @@
 	app/devctl \
 	app/edit \
-	app/ext2info \
 	app/getterm \
 	app/init \
@@ -105,5 +104,4 @@
 	srv/fs/mfs \
 	srv/fs/locfs \
-	srv/fs/ext2fs \
 	srv/fs/ext4fs \
 	srv/hid/compositor \
@@ -218,5 +216,4 @@
 	lib/net \
 	lib/nic \
-	lib/ext2 \
 	lib/ext4 \
 	lib/usb \
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ uspace/Makefile.common	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -118,5 +118,4 @@
 LIBGUI_PREFIX = $(LIB_PREFIX)/gui
 
-LIBEXT2_PREFIX = $(LIB_PREFIX)/ext2
 LIBEXT4_PREFIX = $(LIB_PREFIX)/ext4
 
Index: uspace/app/bdsh/config.h
===================================================================
--- uspace/app/bdsh/config.h	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ uspace/app/bdsh/config.h	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -55,6 +55,3 @@
 #define PACKAGE_STRING "The brain dead shell"
 #define PACKAGE_TARNAME "bdsh"
-#define PACKAGE_VERSION "0.0.1"
-
-
-
+#define PACKAGE_VERSION "0.1.0"
Index: uspace/app/tester/Makefile
===================================================================
--- uspace/app/tester/Makefile	(revision bebf97d3755a1ed2e30dabc28d9f3070933d5cee)
+++ uspace/app/tester/Makefile	(revision c73910287a21883954d2c3d3c7fcbc1668ecc81f)
@@ -29,6 +29,6 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBEXT2_PREFIX)/libext2.a $(LIBBLOCK_PREFIX)/libblock.a $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
-EXTRA_CFLAGS = -I$(LIBBLOCK_PREFIX) -I$(LIBEXT2_PREFIX) -I$(LIBSOFTFLOAT_PREFIX)
+LIBS = $(LIBBLOCK_PREFIX)/libblock.a $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+EXTRA_CFLAGS = -I$(LIBBLOCK_PREFIX) -I$(LIBSOFTFLOAT_PREFIX)
 BINARY = tester
 
@@ -42,4 +42,5 @@
 	print/print4.c \
 	print/print5.c \
+	print/print6.c \
 	console/console1.c \
 	stdio/stdio1.c \
@@ -62,6 +63,5 @@
 	mm/mapping1.c \
 	hw/misc/virtchar1.c \
-	hw/serial/serial1.c \
-	ext2/ext2_1.c
+	hw/serial/serial1.c
 
 include $(USPACE_PREFIX)/Makefile.common
